unit FixMoreNamesUnit;

interface

uses SysUtils, AnePIE, Variables;

Procedure FixMoreOldNames(aneHandle : ANE_PTR);

Procedure CheckForMoreNewLayers(aneHandle : ANE_PTR; var ShowMessage : boolean);

implementation

uses ANECB, ANE_LayerUnit;

Procedure FixMoreOldNames(aneHandle : ANE_PTR);
var
  LayerHandle : ANE_PTR;
  ParamIndex : ANE_INT32;
  UnitIndex : Integer;
  ParameterName : string;
  Expression : string;
  GridLayer : T_ANE_GridLayer;
  AParamList : T_ANE_IndexedParameterList;
  ActiveCellParam : T_ANE_GridParam;

begin
  GridLayer := frmMODFLOW.MFLayerStructure.UnIndexedLayers.
    GetLayerByName(ModflowTypes.GetGridLayerType.ANE_LayerName)
    as T_ANE_GridLayer;

  LayerHandle := ANE_LayerGetHandleByName(aneHandle,
    PChar(ModflowTypes.GetGridLayerType.ANE_LayerName));

  if LayerHandle <> nil then
  begin
    UnitIndex := 0;
    repeat
      ParamIndex := -1;
      AParamList := GridLayer.IndexedParamList1.
        GetNonDeletedIndParameterListByIndex(UnitIndex)
        as T_ANE_IndexedParameterList;

      if AParamList <> nil then
      begin
        Inc (UnitIndex);

        ParameterName := ModflowTypes.GetGridMFActiveCellParamClassType.
          WriteParamName + IntToStr(UnitIndex);

        ParamIndex := ANE_LayerGetParameterByName(aneHandle, layerHandle,
          PChar(ParameterName));

        if ParamIndex > -1 then
        begin
          ActiveCellParam := AParamList.GetParameterByName(ModflowTypes.
            GetGridMFActiveCellParamClassType.ANE_ParamName) as T_ANE_GridParam;

          Expression := ActiveCellParam.Value;

          ANE_LayerSetParameterExpression(aneHandle, layerHandle, ParamIndex,
            PChar(Expression) );
        end;

      end;

    until (AParamList = nil) or (ParamIndex < 0) ;
  end;

end;

Procedure CheckForMoreNewLayers(aneHandle : ANE_PTR; var ShowMessage : boolean);
begin
  // In customized versions, make additional changes here.
end;

end.
