unit functionUnit;

interface

uses 

  AnePIE, FunctionPie;

type
  TParameter_array = array[0..32760] of pointer;
  PParameter_array = ^TParameter_array;

procedure GetANEFunctions( var numNames : ANE_INT32;
          var descriptors : ANEPIEDescPtr ); cdecl;
  
procedure GPIERotatedXFun (const refPtX : ANE_DOUBLE_PTR      ;
				const refPtY : ANE_DOUBLE_PTR     ;
				numParams : ANE_INT16          ;
				const parameters : ANE_PTR_PTR ;
				myHandle : ANE_PTR            ;
				reply : ANE_PTR		       	); cdecl;

implementation

uses UtilityFunctions;

const
  kMaxFunDesc = 20;

var

        gFunDesc : Array [0..kMaxFunDesc-1] of ^ANEPIEDesc;

        gPIERotatedXFDesc :  FunctionPIEDesc;
        gPIERotatedXDesc : ANEPIEDesc;

        gPIERotatedYFDesc :  FunctionPIEDesc;
        gPIERotatedYDesc : ANEPIEDesc;

const   gpnXYAngle : array [0..3] of PChar = ('X', 'Y', 'GridAngle', nil);
const   g3FloatTypes : array [0..3] of EPIENumberType = (kPIEFloat, kPIEFloat, kPIEFloat, 0);

procedure GPIERotatedXFun (const refPtX : ANE_DOUBLE_PTR      ;
				const refPtY : ANE_DOUBLE_PTR     ;
				numParams : ANE_INT16          ;
				const parameters : ANE_PTR_PTR ;
				myHandle : ANE_PTR            ;
				reply : ANE_PTR		       	); cdecl;
var
  param : PParameter_array;
//  StringtoEvaluate :ANE_STR;
  param1_ptr : ANE_DOUBLE_PTR;  // ANE_DOUBLE_PTR is the same as ^ANE_DOUBLE
  X : ANE_DOUBLE;
  param2_ptr : ANE_DOUBLE_PTR;  // ANE_DOUBLE_PTR is the same as ^ANE_DOUBLE
  Y : ANE_DOUBLE;
  param3_ptr : ANE_DOUBLE_PTR;  // ANE_DOUBLE_PTR is the same as ^ANE_DOUBLE
  Angle : ANE_DOUBLE;
//  result : ANE_DOUBLE;
begin
  param := @parameters^;
  param1_ptr :=  param^[0];
  X :=  param1_ptr^;
  param2_ptr :=  param^[1];
  Y :=  param2_ptr^;
  param3_ptr :=  param^[2];
  Angle :=  param3_ptr^;

  RotatePointsFromGrid(X, Y, Angle);

  ANE_DOUBLE_PTR(reply)^ := X;
end;

procedure GPIERotatedYFun (const refPtX : ANE_DOUBLE_PTR      ;
				const refPtY : ANE_DOUBLE_PTR     ;
				numParams : ANE_INT16          ;
				const parameters : ANE_PTR_PTR ;
				myHandle : ANE_PTR            ;
				reply : ANE_PTR		       	); cdecl;
var
  param : PParameter_array;
//  StringtoEvaluate :ANE_STR;
  param1_ptr : ANE_DOUBLE_PTR;  // ANE_DOUBLE_PTR is the same as ^ANE_DOUBLE
  X : ANE_DOUBLE;
  param2_ptr : ANE_DOUBLE_PTR;  // ANE_DOUBLE_PTR is the same as ^ANE_DOUBLE
  Y : ANE_DOUBLE;
  param3_ptr : ANE_DOUBLE_PTR;  // ANE_DOUBLE_PTR is the same as ^ANE_DOUBLE
  Angle : ANE_DOUBLE;
//  result : ANE_DOUBLE;
begin
  param := @parameters^;
  param1_ptr :=  param^[0];
  X :=  param1_ptr^;
  param2_ptr :=  param^[1];
  Y :=  param2_ptr^;
  param3_ptr :=  param^[2];
  Angle :=  param3_ptr^;

  RotatePointsFromGrid(X, Y, Angle);

  ANE_DOUBLE_PTR(reply)^ := Y;
end;

procedure GetANEFunctions( var numNames : ANE_INT32;
          var descriptors : ANEPIEDescPtr ); cdecl;
begin

	numNames := 0;

	gPIERotatedXFDesc.name := 'Rotated X';	        // name of function
	gPIERotatedXFDesc.address := GPIERotatedXFun;		// function address
	gPIERotatedXFDesc.returnType := kPIEFloat;		// return value type
	gPIERotatedXFDesc.numParams :=  3;			// number of parameters
	gPIERotatedXFDesc.numOptParams := 0;			// number of optional parameters
	gPIERotatedXFDesc.paramNames := @gpnXYAngle;		// pointer to parameter names list
	gPIERotatedXFDesc.paramTypes := @g3FloatTypes;	// pointer to parameters types list

       	gPIERotatedXDesc.name  := 'Rotated X';		// name of PIE
	gPIERotatedXDesc.PieType :=  kFunctionPIE;		// PIE type: PIE function
	gPIERotatedXDesc.descriptor := @gPIERotatedXFDesc;	// pointer to descriptor

        {$ASSERTIONS ON}
        {Assertions are a debugging tool. They should be turned off
        in the final version. They are useful for "Just-in-time" debugging
        with Turbo-Debugger 32. See Delphi help for more information.}
	Assert (numNames < kMaxFunDesc) ;
	gFunDesc[numNames] := @gPIERotatedXDesc;  // add descriptor to list
        Inc(numNames);	// increment number of names

	gPIERotatedYFDesc.name := 'Rotated Y';	        // name of function
	gPIERotatedYFDesc.address := GPIERotatedYFun;		// function address
	gPIERotatedYFDesc.returnType := kPIEFloat;		// return value type
	gPIERotatedYFDesc.numParams :=  3;			// number of parameters
	gPIERotatedYFDesc.numOptParams := 0;			// number of optional parameters
	gPIERotatedYFDesc.paramNames := @gpnXYAngle;		// pointer to parameter names list
	gPIERotatedYFDesc.paramTypes := @g3FloatTypes;	// pointer to parameters types list

       	gPIERotatedYDesc.name  := 'Rotated Y';		// name of PIE
	gPIERotatedYDesc.PieType :=  kFunctionPIE;		// PIE type: PIE function
	gPIERotatedYDesc.descriptor := @gPIERotatedYFDesc;	// pointer to descriptor

	Assert (numNames < kMaxFunDesc) ;
	gFunDesc[numNames] := @gPIERotatedYDesc;  // add descriptor to list
        Inc(numNames);	// increment number of names

{        gPIERotatedXFDesc :  FunctionPIEDesc;
        gPIERotatedXDesc : ANEPIEDesc;

        gPIERotatedYFDesc :  FunctionPIEDesc;
        gPIERotatedYDesc : ANEPIEDesc; }


	descriptors := @gFunDesc;

end;

end.
