unit ParamNamesAndTypes;

interface

{ParamNamesAndTypes defines parameter names and parameter types for use in
 PIE functions.}

uses AnePIE;

// names
const   gpnPeriod : array [0..1] of PChar = ('Period', nil);
const   gpnUnit : array [0..1] of PChar = ('Unit', nil);
const   gpnNodeLayer : array [0..1] of PChar = ('NodeLayer', nil);
const   gpnNode : array [0..1] of PChar = ('Node', nil);
const   gpnNodeExpression : array [0..2] of PChar = ('Node', 'Expression', nil);
const   gpnElement : array [0..1] of PChar = ('Element', nil);
const   gpnElementExpression : array [0..2] of PChar = ('Element',  'Expression', nil);
const   gpnExpression : array [0..1] of PChar = ('Expression', nil);
const   gpnElementLayer : array [0..1] of PChar = ('ElementLayer', nil);
const   gpnTime : array [0..1] of PChar = ('Time', nil);
const   gpnNumber : array [0..1] of PChar = ('Number', nil);
const   gpnModflowLayerNames : array [0..4] of PChar = ('Unit', 'Top_Elevation',
  'Bottom_Elevation', 'Elevation', nil);
const   gpnTimeIndex : array [0..1] of PChar = ('Time_Index', nil);
const   gpnZone : array [0..1] of PChar = ('ZoneIndex', nil);
const   gpnFrozen : array [0..1] of PChar = ('Frozen', nil);
const   gpnColumnRow : array [0..2] of PChar = ('Column','Row', nil);
const   gpnElementLayerName : array [0..1] of PChar = ('ElementLayerName', nil);
const   gpnLayerParam : array [0..3] of PChar = ('ElementLayerName', 'ParameterName', 'FileName', nil);
const   gpnLayerParamNode : array [0..4] of PChar = ('ElementLayerName', 'ParameterName', 'Node', 'FileName', nil);
const   gpnLayerParamElem : array [0..4] of PChar = ('ElementLayerName', 'ParameterName', 'Element', 'FileName', nil);
const   gpnContourOverride : array [0..2] of PChar = ('ContourIndex', 'IsOverridden', nil);
const   gpnElementNode : array [0..2] of PChar = ('Element', 'Node', nil);
const   gpnLayerParameterNode : array [0..2] of PChar = ('Mesh_Layer', 'Parameter', 'Node_Number');
const   gpnFile : array [0..1] of PChar = ('File', nil);
const   gpnElevation : array [0..1] of PChar = ('Elevation', nil);


const   gOneIntegerTypes : array [0..1] of EPIENumberType = (kPIEInteger, 0);
const   gOneDoubleTypes : array [0..1] of EPIENumberType = (kPIEFloat, 0);
const   g1Integer3RealTypes : array [0..4] of EPIENumberType =
  (kPIEInteger, kPIEFloat, kPIEFloat, kPIEFloat, 0);
const   gOneBooleanTypes : array [0..1] of EPIENumberType = (kPIEBoolean, 0);
const   gTwoIntegerTypes : array [0..2] of EPIENumberType = (kPIEInteger, kPIEInteger, 0);
const   gOneStringTypes  : array [0..1] of EPIENumberType = (kPIEString, 0);
const   g2StringTypes  : array [0..2] of EPIENumberType = (kPIEString, kPIEString, 0);
const   g2String2IntegerTypes  : array [0..3] of EPIENumberType = (kPIEString, kPIEString, kPIEInteger, 0);
const   g3StringTypes  : array [0..3] of EPIENumberType = (kPIEString, kPIEString, kPIEString, 0);
const   gOneIntegerStringTypes : array [0..2] of EPIENumberType = (kPIEInteger, kPIEString, 0);
const   gOneIntegerBoolTypes : array [0..2] of EPIENumberType = (kPIEInteger, kPIEBoolean, 0);

implementation

end.
